000010*@M              MAIN
000020 IDENTIFICATION DIVISION.
000030 PROGRAM-ID. SHX001.
000040 DATE-COMPILED.
000050* ------------------------: GS General-purpose Test Program.
000060*                         : Use to test any GUI ScreenIO panel...
000070*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000080 ENVIRONMENT DIVISION.
000090* 150605ja-64 fIX UNRELIABLE CSV LAUNCH                           150605ja
000100* 150605ja-63 Strip out popup and such                            150605ja
000110* 150605ja-57 fix csv xfer                                        150605ja
000120* 120911ja-56 Added PDF to demo                                   120911ja
000130* 090807ja-55 Add XML file
000140* 090806ja-51 ADDED SPREADSHEET
000150* 090806ja-50 add popup and propsheet test cases
000160*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000170 CONFIGURATION SECTION.
000180 SOURCE-COMPUTER. IBM-PC.
000190 OBJECT-COMPUTER. IBM-PC.
000200*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000210 DATA DIVISION.
000220*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000230 WORKING-STORAGE SECTION.
000240 01  V--VERSION-LEVEL                 PIC 9(3) VALUE 64.          150605ja
000250*
000260         COPY WIN32API.
000270         COPY SHELLEXE.
000280* ------------------------: Copy a main panel (any will do)
000290         COPY SHXMAIN.
000300*
000310* ------------------------: Copy the panel to be tested below.
000320         COPY SHXBASE.
000330         COPY SHXPOP1.
000340         COPY SHXPROP.
000350*
000360*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000370 PROCEDURE DIVISION.
000380*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000390*
000400     PERFORM 0102-INITIALIZE-GS.
000410*
000420* ------------------------: Display the test panel.
000430*
000440     PERFORM WITH TEST AFTER
000450           UNTIL SHXBASE-EVENT-CLOSE-WINDOW
000460           OR SHXBASE-EVENT-CLOSE-AND-STOP
000470           OR SHXBASE-EXIT
000480*
000490       CALL 'GS' USING SHXBASE-1
000500                       SHXBASE-2
000510                       SHXBASE-3
000520                       SHXBASE-4
000530*
000540       MOVE LOW-VALUES TO SHELLEXE-FILETYPEID SHELLEXE-ARGUMENTS
000550       EVALUATE TRUE
000560         WHEN SHXBASE-DOC-CSV-OPEN
000570           MOVE 'WHATHAPPENED.CSV' TO SHELLEXE-FILE-URL           150605ja
000580           SET SHELLEXE-OPEN TO TRUE
000590*                         : This may be needed for users without  150605ja
000600*                         : excel, because there is not always    150605ja
000610*                         : a .csv in the registry                150605ja
000620           PERFORM 0101-OPEN-IT-SESME
000630           IF WIN32API-FAILED                                     150605ja
000640             STRING "soffice.StarCalcDocument.6" DELIMITED SIZE   150605ja
000650                 LOW-VALUE                                        150605ja
000660                 DELIMITED SIZE INTO SHELLEXE-FILETYPEID          150605ja
000670             PERFORM 0101-OPEN-IT-SESME                           150605ja
000680             IF NOT WIN32API-FAILED                               150605ja
000690               MOVE SPACE TO SHXBASE-MESSAGE-TEXT                 150605ja
000700               SET SHXBASE-MESSAGE-NOT-DISPLAYED TO TRUE          150605ja
000710             END-IF                                               150605ja
000720           END-IF                                                 150605ja
000730*
000740         WHEN SHXBASE-DOC-XLS-OPEN
000750           MOVE 'WHATHAPPENED.XLS' TO SHELLEXE-FILE-URL           150605ja
000760           SET SHELLEXE-OPEN TO TRUE
000770           PERFORM 0101-OPEN-IT-SESME
000780*
000790         WHEN SHXBASE-DOC-XML-OPEN
000800           MOVE 'WHATHAPPENED.XML' TO SHELLEXE-FILE-URL
000810           SET SHELLEXE-OPEN TO TRUE
000820           STRING "excel.sheet.8" DELIMITED SPACE LOW-VALUE
000830               DELIMITED SIZE INTO SHELLEXE-FILETYPEID
000840           PERFORM 0101-OPEN-IT-SESME
000850*
000860         WHEN SHXBASE-WRI-DOC-OPEN
000870           MOVE 'WHATHAPPENED.WRI' TO SHELLEXE-FILE-URL           150605ja
000880           SET SHELLEXE-OPEN TO TRUE
000890           PERFORM 0101-OPEN-IT-SESME
000900*
000910         WHEN SHXBASE-DOC-PDF-OPEN                                120911ja
000920           MOVE 'WHATHAPPENED.PDF' TO SHELLEXE-FILE-URL           120911ja
000930           SET SHELLEXE-OPEN TO TRUE                              120911ja
000940           PERFORM 0101-OPEN-IT-SESME                             120911ja
000950*                                                                 120911ja
000960         WHEN SHXBASE-WRI-DOC-PRINT
000970           MOVE 'WHATHAPPENED.TXT' TO SHELLEXE-FILE-URL
000980           SET SHELLEXE-PRINT TO TRUE
000990           PERFORM 0101-OPEN-IT-SESME
001000*
001010         WHEN SHXBASE-DOC-DOC-OPEN
001020           MOVE 'WHATHAPPENED.DOC' TO SHELLEXE-FILE-URL
001030           SET SHELLEXE-OPEN TO TRUE
001040           PERFORM 0101-OPEN-IT-SESME
001050*
001060         WHEN SHXBASE-DOC-DOC-PRINT
001070           MOVE 'WHATHAPPENED.DOC' TO SHELLEXE-FILE-URL
001080           SET SHELLEXE-PRINT TO TRUE
001090           PERFORM 0101-OPEN-IT-SESME
001100*
001110         WHEN SHXBASE-DOC-PDF-PRINT                               120911ja
001120           MOVE 'WHATHAPPENED.PDF' TO SHELLEXE-FILE-URL           120911ja
001130           SET SHELLEXE-PRINT TO TRUE                             120911ja
001140           PERFORM 0101-OPEN-IT-SESME                             120911ja
001150*
001160       END-EVALUATE
001170     END-PERFORM.
001180*
001190* ------------------------: Close the main before doing a STOP RUN
001200*
001210     SET SHXMAIN-DO-CLOSE TO TRUE.
001220     CALL 'GS' USING SHXMAIN-1
001230                     SHXMAIN-2
001240                     SHXMAIN-3
001250                     SHXMAIN-4.
001260     STOP RUN.
001270*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
001280 0100-GS-UTILITY SECTION.
001290* -====-
001300 0101-OPEN-IT-SESME.
001310     SET SE-SW-SHOWNORMAL TO TRUE
001320     IF LAUNCH-MAX-ON
001330       SET SE-SW-SHOWMAXIMIZED TO TRUE
001340     END-IF
001350     SET FUNC-SHELLEXECUTE TO TRUE.
001360     CALL 'GSWINAPI' USING WIN32API-PARMS
001370                           SHELLEXE-CMDSHOW
001380                           SHELLEXE-FILETYPEID
001390                           SHELLEXE-VERB
001400                           SHELLEXE-FILE-URL
001410                           SHELLEXE-ARGUMENTS
001420                           WIN32API-F.
001430     IF WIN32API-FAILED                                           150605ja
001440       MOVE 'NO LOCAL SOFTWARE INSTALLED' TO SHXBASE-MESSAGE-TEXT 150605ja
001450       SET SHXBASE-MESSAGE-BAR-BEEP TO TRUE.                      150605ja
001460* -====-
001470*
001480 0102-INITIALIZE-GS.
001490*                         :---------------------------------------
001500* ------------------------: Open the application window (the
001510*                         : container for this application)
001520*                         :---------------------------------------
001530*
001540     CALL 'GS' USING SHXMAIN-1
001550                     SHXMAIN-2
001560                     SHXMAIN-3
001570                     SHXMAIN-4.
